<template>
  <div v-if="!successSend && !sendFailed">
    <div v-if="theme === 'canvas_paper' || theme === 'canvas'">
      <div class="mb-2 text-3xl">Заказать интерьерную печать</div>
      <div class="mb-5 text-sm opacity-20 mx-auto hover:opacity-70">Оставьте заявку и мы свяжемся с вами для уточнения деталей заказа</div>
    </div>
    <div v-else-if="theme === 'cup'">
      <div class="mb-2 text-3xl">Заказать кружку</div>
      <div class="mb-5 text-sm opacity-20 mx-auto hover:opacity-70">Оставьте заявку и мы свяжемся с вами для уточнения деталей заказа и поможем состовить дизайн</div>
    </div>
    <div v-else-if="theme === 'puzzles'">
      <div class="mb-2 text-3xl">Заказать пазлы</div>
      <div class="mb-5 text-sm opacity-20 mx-auto hover:opacity-70">Оставьте заявку и мы свяжемся с вами для уточнения деталей заказа и поможем состовить дизайн</div>
    </div>
    <form>
      <input
        class="inputField"
        type="text"
        placeholder="Имя"
        v-model="form.name"
      />
      <label :class="{'error': error === 'phone'}" class="phone">
        <input
          class="inputField my-2"
          type="phone"
          placeholder="Телефон"
          v-model="form.phone"
        />
        <span v-if="error === 'phone'" class="error-message">{{errorMessage}}</span>
      </label>
      <input
        class="inputField"
        type="email"
        placeholder="Email (не обязательно)"
        v-model="form.email"
      />
      <div class="flex justify-end items-center mt-6">
        <label v-if="1===2" class="cursor-pointer flex items-center">
          <span class="mr-2 mb-0">Прикрепить файл</span>
          <img class="w-6" src="../assets/images/icons/file-image-plus-outline.png" alt="">
          <input
            class="inputField"
            type="file"
            hidden
          />
        </label>
        <div @click="send" class="button w-1/3">Заказать <LoadsSpinner small v-if="loading"/> </div>
      </div>
    </form>
  </div>
  <div v-else-if="successSend">
    <div class="text-white text-2xl my-10">
      Заявка успешно отправлена!
    </div>
  </div>
  <div v-if="sendFailed">
    <div class="text-red-700 text-2xl my-10">
      <p class="mb-4">Ошибка</p>
      <p>Попробуйте позже или обновите страницу..</p>
    </div>
  </div>
</template>

<script>
import {computed, reactive, ref, toRefs, watch} from "vue";
import LoadsSpinner from "./Loads-spinner.vue";
import {useStore} from "vuex";
import {supabase} from "../supabase";

export default {
  name: "Form",
  components: {LoadsSpinner},
  props: {
    theme: {
      type: String,
      default: ''
    },
    file: {
      type: Boolean,
      default: false
    },
  },
  emits: ["addToOrders"],
  setup(prop, { emit }) {
    const store = useStore()
    let user = computed(function () {
      return store.state.user
    });

    const loading = ref(false)
    const successSend = ref(false)
    const sendFailed = ref(false)
    const { theme } = toRefs(prop)
    const form = reactive(
      {
        name: null,
        phone: null,
        email: null,
      }
    )

    const error = ref(null)
    const errorMessage = ref('')
    async function send() {
      loading.value = true
      if (!form.phone) {
        error.value = 'phone'
        errorMessage.value = 'Укажите ваш номер'
        loading.value = false
      } else if (form.phone.length > 11 || form.phone.length < 11) {
        error.value = 'phone'
        errorMessage.value = 'Формат: 89886126261'
        loading.value = false
      } else {
        try {
          loading.value = true
          const orderId = Math.floor(Math.random() * (999999 - 1 + 1)) + 1
          const updates = {
            owner: user && user.id || null,
            name: theme.value,
            username: form.name || 'Не указано',
            phone: form.phone,
            email: form.email || 'Не указан',
            order_id: orderId,
          }
          let { error } = await supabase.from(user && user.id ? 'orders' : 'orders_not_auth').insert(updates)
          loading.value = false
          if (error) throw error
          successSend.value = true
          let data = {}
          data.name = theme.value
          data.email = form.email
          data.id = String(orderId)
          data.message = 'Новый заказ!!!'
          await fetch('https://foto09.ru/send.php', {
            headers: {
              'Content-Type': 'multipart/form-data'
            },
            method: 'POST'
          })
        } catch (error) {
          console.log(error.message)
          sendFailed.value = true
        } finally {
          loading.value = false
        }
      }
    }


    watch(form, () => {
      error.value = null
      errorMessage.value = ''
    })
    return {
      form,
      loading,
      successSend,
      sendFailed,
      error,
      errorMessage,
      send
    }
  }
}
</script>

<style scoped lang="scss">
.phone {
  margin: 0; position: relative; font-size: initial;
  &.error {
    input {
      border: 1px solid darkred;
      &:focus-visible {
        outline: 1.5px solid darkred;
      }
    }
  }
  span {
    position: absolute;
    left: 50%;
    font-size: 11px;
    top: -5px;
    width: fit-content;
    color: #cecece;
    padding: 5px;
    background: #3d3d3d;
    border-radius: 3px;
    &:before {
      content: '▼';
      color: #3d3d3d;
      position: absolute;
      left: 50%;
      transform: translate(-50%, calc(100% - 1px));
    }
  }
}
</style>
